from GraphGrammarEdit import *
from GGruleEdit import *

def savedTrans(self):
   self.EditingGraphGrammar= GraphGrammarEdit(None, self)
   self.EditingGraphGrammar.Name=ATOM3String('trsf_const_fold')
   self.EditingGraphGrammar.Rules=ATOM3List([ 1, 1, 1, 0],GGruleEdit,None, self)
   lcobj0=[]
   cobj0= GGruleEdit(None, self)
   cobj0.Name=ATOM3String('fold_operator')
   cobj0.Order=ATOM3Integer(2)

   from constant import *
   from ASG_algebra_entities import *
   from alg_operator import *
   from operates_on import *

   cobj0.LHS = ASG_algebra_entities(self)

   self.obj23=alg_operator(self)

   self.obj23.kind.setNone()
   self.obj23.kind.config = 0
   self.obj23.GGLabel.setValue(1)
   self.obj23.graphClass_= graph_alg_operator
   if self.genGraphics:
      from graph_alg_operator import *
      new_obj = graph_alg_operator(200.0,99.0,self.obj23)
   else: new_obj = None
   self.obj23.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj23)

   self.obj24=operates_on(self)

   self.obj24.GGLabel.setValue(2)
   self.obj24.graphClass_= graph_operates_on
   if self.genGraphics:
      from graph_operates_on import *
      new_obj = graph_operates_on(183.0,187.0,self.obj24)
   else: new_obj = None
   self.obj24.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj24)

   self.obj25=operates_on(self)

   self.obj25.GGLabel.setValue(0)
   self.obj25.graphClass_= graph_operates_on
   if self.genGraphics:
      from graph_operates_on import *
      new_obj = graph_operates_on(140.0,31.0,self.obj25)
   else: new_obj = None
   self.obj25.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj25)
   self.obj23.out_connections_.append(self.obj24)
   self.obj24.in_connections_.append(self.obj23)
   self.obj25.out_connections_.append(self.obj23)
   self.obj23.in_connections_.append(self.obj25)
   cobj0.RHS = ASG_algebra_entities(self)

   self.obj27=constant(self)

   self.obj27.value.setValue(0)
   self.obj27.GGLabel.setValue(3)
   self.obj27.graphClass_= graph_constant
   if self.genGraphics:
      from graph_constant import *
      new_obj = graph_constant(311.0,134.0,self.obj27)
   else: new_obj = None
   self.obj27.graphObject_ = new_obj
   self.obj270= AttrCalc()
   self.obj270.Copy=ATOM3Boolean()
   self.obj270.Copy.setValue(('Copy from LHS', 0))
   self.obj270.Copy.config = 0
   self.obj270.Specify=ATOM3Constraint()
   self.obj270.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# This code should only be executed if the condition "all arguments to the operator\n# are constants" is satisfied.\n# The single constant node (self) will have the value obtained by\n# constant folding the operator over all its arguments.\n\n# All the constant arguments have been folded and hence need to be deleted\n# (by the del_marked_constants rule with priority 1).\n# To make that rule find the constants to be deleted, all constant arguments\'\n# to_delete (Python) attributes are set to True (1).\n\nargument_list = self.getMatched(graphID, self.LHS.nodeWithLabel(2)).out_connections_\nfor arg in argument_list:\n arg.to_delete = 1\n\n# All the constant arguments have been folded into a single constant node.\n# This is a newly created "constant" node and hence has no "to_delete" attribute yet.\n# Give it one (and set to False)\nself.getMatched(graphID, self.RHS.nodeWithLabel(3)).to_delete = 0\n\n# Find out what the operator is. As "alg_operator"\'s attribute "kind" is\n# an enumerated type, a tuple like ([\'+\', \'*\', \'inv\'], 0) will be returned.\n# The 0 is the position in the list of the operator\'s description (\'+\' in this case).\n(operator_enum, operator_index) = self.getMatched(graphID, self.LHS.nodeWithLabel(1)).kind.getValue()\noperator = operator_enum[operator_index]\n\n# set the initial folding result (only implemented for + and *)\nif operator == \'+\':\n result = 0\nelif operator == \'*\':\n result = 1\nelif operator == \'inv\':\n result = 0\nelse:\n result = -9999\n\n# apply the operator to all arguments\nfor arg in argument_list:\n value = arg.value.getValue()\n if operator == \'+\':\n  result += value\n elif operator == \'*\':\n  result *= value\n elif operator == \'inv\':\n  result -= value \n else:\n  print "constant folding not implemented for operator \'%s\'" % operator\n\n# Return the folded value \nreturn result\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n'))
   self.obj27.GGset2Any['value']= self.obj270
   cobj0.RHS.addNode(self.obj27)

   self.obj28=operates_on(self)

   self.obj28.GGLabel.setValue(0)
   self.obj28.graphClass_= graph_operates_on
   if self.genGraphics:
      from graph_operates_on import *
      new_obj = graph_operates_on(243.0,48.0,self.obj28)
   else: new_obj = None
   self.obj28.graphObject_ = new_obj
   cobj0.RHS.addNode(self.obj28)
   self.obj28.out_connections_.append(self.obj27)
   self.obj27.in_connections_.append(self.obj28)
   cobj0.Condition=ATOM3Constraint()
   cobj0.Condition.setValue(('condition', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# Only constant fold if all arguments are constants\nargument_list = self.getMatched(graphID, self.LHS.nodeWithLabel(2)).out_connections_\nfor arg in argument_list:\n if not isinstance(arg, constant): return 0\nreturn 1\n\n\n\n\n\n'))
   cobj0.Action=ATOM3Constraint()
   cobj0.Action.setValue(('action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# All the constant arguments have been folded and hence need to be deleted\n# (by the del_marked_constants rule with priority 1).\n# To make that rule find the constants to be deleted, all constant arguments\'\n# to_delete (Python) attributes are set to True (1).\n\nprint ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"\nprint dir(self)\n\nargument_list = self.getMatched(graphID, self.LHS.nodeWithLabel(2)).out_connections_\nfor arg in argument_list:\n arg.to_delete = 1\n\n# All the constant arguments have been folded into a single constant node.\n# This is a newly created "constant" node and hence has no "to_delete" attribute yet.\n# Give it one (and set to False)\nself.getMatched(graphID, self.RHS.nodeWithLabel(3)).to_delete = 0\n\n\n\n\n\n\n'))
   lcobj0.append(cobj0)
   cobj0= GGruleEdit(None, self)
   cobj0.Name=ATOM3String('del_marked_constants')
   cobj0.Order=ATOM3Integer(1)

   from constant import *
   from ASG_algebra_entities import *
   from alg_operator import *
   from operates_on import *

   cobj0.LHS = ASG_algebra_entities(self)

   self.obj33=constant(self)

   self.obj33.value.setNone()
   self.obj33.GGLabel.setValue(0)
   self.obj33.graphClass_= graph_constant
   if self.genGraphics:
      from graph_constant import *
      new_obj = graph_constant(244.0,121.0,self.obj33)
   else: new_obj = None
   self.obj33.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj33)
   cobj0.RHS = ASG_algebra_entities(self)
   cobj0.Condition=ATOM3Constraint()
   cobj0.Condition.setValue(('condition', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'return self.getMatched(graphID, self.LHS.nodeWithLabel(0)).to_delete\n\n\n\n\n'))
   cobj0.Action=ATOM3Constraint()
   cobj0.Action.setValue(('action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
   lcobj0.append(cobj0)
   cobj0= GGruleEdit(None, self)
   cobj0.Name=ATOM3String('fold_operator_top')
   cobj0.Order=ATOM3Integer(3)

   from constant import *
   from ASG_algebra_entities import *
   from alg_operator import *
   from operates_on import *

   cobj0.LHS = ASG_algebra_entities(self)

   self.obj39=alg_operator(self)

   self.obj39.kind.setNone()
   self.obj39.kind.config = 0
   self.obj39.GGLabel.setValue(1)
   self.obj39.graphClass_= graph_alg_operator
   if self.genGraphics:
      from graph_alg_operator import *
      new_obj = graph_alg_operator(197.0,60.0,self.obj39)
   else: new_obj = None
   self.obj39.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj39)

   self.obj40=operates_on(self)

   self.obj40.GGLabel.setValue(2)
   self.obj40.graphClass_= graph_operates_on
   if self.genGraphics:
      from graph_operates_on import *
      new_obj = graph_operates_on(339.0,135.0,self.obj40)
   else: new_obj = None
   self.obj40.graphObject_ = new_obj
   cobj0.LHS.addNode(self.obj40)
   self.obj39.out_connections_.append(self.obj40)
   self.obj40.in_connections_.append(self.obj39)
   cobj0.RHS = ASG_algebra_entities(self)

   self.obj42=constant(self)

   self.obj42.value.setValue(0)
   self.obj42.GGLabel.setValue(3)
   self.obj42.graphClass_= graph_constant
   if self.genGraphics:
      from graph_constant import *
      new_obj = graph_constant(241.0,104.0,self.obj42)
   else: new_obj = None
   self.obj42.graphObject_ = new_obj
   self.obj420= AttrCalc()
   self.obj420.Copy=ATOM3Boolean()
   self.obj420.Copy.setValue(('Copy from LHS', 0))
   self.obj420.Copy.config = 0
   self.obj420.Specify=ATOM3Constraint()
   self.obj420.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# This code should only be executed if the condition "all arguments to the operator\n# are constants" is satisfied.\n# The single constant node (self) will have the value obtained by\n# constant folding the operator over all its arguments.\n\n# All the constant arguments have been folded and hence need to be deleted\n# (by the del_marked_constants rule with priority 1).\n# To make that rule find the constants to be deleted, all constant arguments\'\n# to_delete (Python) attributes are set to True (1).\n\nargument_list = self.getMatched(graphID, self.LHS.nodeWithLabel(2)).out_connections_\nfor arg in argument_list:\n arg.to_delete = 1\n\n# All the constant arguments have been folded into a single constant node.\n# This is a newly created "constant" node and hence has no "to_delete" attribute yet.\n# Give it one (and set to False)\nself.getMatched(graphID, self.RHS.nodeWithLabel(3)).to_delete = 0\n\n# Find out what the operator is. As "alg_operator"\'s attribute "kind" is\n# an enumerated type, a tuple like ([\'+\', \'*\', \'inv\'], 0) will be returned.\n# The 0 is the position in the list of the operator\'s description (\'+\' in this case).\n(operator_enum, operator_index) = self.getMatched(graphID, self.LHS.nodeWithLabel(1)).kind.getValue()\noperator = operator_enum[operator_index]\n\n# set the initial folding result (only implemented for + and *)\nif operator == \'+\':\n result = 0\nelif operator == \'*\':\n result = 1\nelif operator == \'inv\':\n result = 0\nelse:\n result = -9999\n\n# apply the operator to all arguments\nfor arg in argument_list:\n value = arg.value.getValue()\n if operator == \'+\':\n  result += value\n elif operator == \'*\':\n  result *= value\n elif operator == \'inv\':\n  result -= value\n else:\n  print "constant folding not implemented for operator \'%s\'" % operator\n\n# Return the folded value \nreturn result\n\n\n\n\n\n\n\n\n'))
   self.obj42.GGset2Any['value']= self.obj420
   cobj0.RHS.addNode(self.obj42)
   cobj0.Condition=ATOM3Constraint()
   cobj0.Condition.setValue(('condition', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# Only constant fold if all arguments are constants\nargument_list = self.getMatched(graphID, self.LHS.nodeWithLabel(2)).out_connections_\nfor arg in argument_list:\n if not isinstance(arg, constant): return 0\nreturn 1\n\n\n'))
   cobj0.Action=ATOM3Constraint()
   cobj0.Action.setValue(('action', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# All the constant arguments have been folded and hence need to be deleted\n# (by the del_marked_constants rule with priority 1).\n# To make that rule find the constants to be deleted, all constant arguments\'\n# to_delete (Python) attributes are set to True (1).\n\nargument_list = self.getMatched(graphID, self.LHS.nodeWithLabel(2)).out_connections_\nfor arg in argument_list:\n arg.to_delete = 1\n\n# All the constant arguments have been folded into a single constant node.\n# This is a newly created "constant" node and hence has no "to_delete" attribute yet.\n# Give it one (and set to False)\nself.getMatched(graphID, self.RHS.nodeWithLabel(3)).to_delete = 0\n\n\n'))
   lcobj0.append(cobj0)
   self.EditingGraphGrammar.Rules.setValue(lcobj0)
   self.EditingGraphGrammar.InitialAction=ATOM3Constraint()
   self.EditingGraphGrammar.InitialAction.setValue(('add_to_delete', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# Add the attribute "to_delete" to all "constant" nodes.\n#\n# Constant nodes with this attribute set to True (1) will be deleted\n# by the Graph Grammar rule del_marked_constants (with priority 1).\n# Initially, to_delete is set to False (0) for all constant nodes.\n#\n# "to_delete" is a plain Python attribute, not an AToM3 attribute\n# (it is not present in the meta-model).\n# This approach is taken as we do not want the user to see this attribute\n# when editing a model (which is what would happen if the attribute were\n# present in the meta-model).\n# As "to_delete" is a plain Python attributed, we access its value\n# by self.getMatched(graphID, self.LHS.nodeWithLabel(N)).to_delete\n# and NOT by self.getMatched(graphID, self.LHS.nodeWithLabel(N)).to_delete.getValue()\n# The latter is only necessary to access AToM3 attributes.\n\nfor node in graph.listNodes["constant"]:\n  node.to_delete = 0\n\n\n\n\n\n\n\n'))
   self.EditingGraphGrammar.FinalAction=ATOM3Constraint()
   self.EditingGraphGrammar.FinalAction.setValue(('remove_to_delete', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# Remove the helper attribute "to_delete" from all "constant" nodes\n\nfor node in graph.listNodes["constant"]:\n  del node.to_delete\n\n\n\n\n\n'))


