# _ fold_operator.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from constant import *
from ASG_algebra_entities import *
from alg_operator import *
from operates_on import *
class fold_operator (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 2)
      self.LHS = ASG_algebra_entities(parent)

      self.obj23=alg_operator(parent)

      self.obj23.kind.setNone()
      self.obj23.kind.config = 0
      self.obj23.GGLabel.setValue(1)
      self.obj23.graphClass_= graph_alg_operator
      if parent.genGraphics:
         from graph_alg_operator import *
         new_obj = graph_alg_operator(200.0,99.0,self.obj23)
      else: new_obj = None
      self.obj23.graphObject_ = new_obj
      self.LHS.addNode(self.obj23)

      self.obj24=operates_on(parent)

      self.obj24.GGLabel.setValue(2)
      self.obj24.graphClass_= graph_operates_on
      if parent.genGraphics:
         from graph_operates_on import *
         new_obj = graph_operates_on(183.0,187.0,self.obj24)
      else: new_obj = None
      self.obj24.graphObject_ = new_obj
      self.LHS.addNode(self.obj24)

      self.obj25=operates_on(parent)

      self.obj25.GGLabel.setValue(0)
      self.obj25.graphClass_= graph_operates_on
      if parent.genGraphics:
         from graph_operates_on import *
         new_obj = graph_operates_on(140.0,31.0,self.obj25)
      else: new_obj = None
      self.obj25.graphObject_ = new_obj
      self.LHS.addNode(self.obj25)
      self.obj23.out_connections_.append(self.obj24)
      self.obj24.in_connections_.append(self.obj23)
      self.obj25.out_connections_.append(self.obj23)
      self.obj23.in_connections_.append(self.obj25)
      self.RHS = ASG_algebra_entities(parent)

      self.obj27=constant(parent)

      self.obj27.value.setValue(0)
      self.obj27.GGLabel.setValue(3)
      self.obj27.graphClass_= graph_constant
      if parent.genGraphics:
         from graph_constant import *
         new_obj = graph_constant(311.0,134.0,self.obj27)
      else: new_obj = None
      self.obj27.graphObject_ = new_obj
      self.obj270= AttrCalc()
      self.obj270.Copy=ATOM3Boolean()
      self.obj270.Copy.setValue(('Copy from LHS', 0))
      self.obj270.Copy.config = 0
      self.obj270.Specify=ATOM3Constraint()
      self.obj270.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 1), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '# This code should only be executed if the condition "all arguments to the operator\n# are constants" is satisfied.\n# The single constant node (self) will have the value obtained by\n# constant folding the operator over all its arguments.\n\n# All the constant arguments have been folded and hence need to be deleted\n# (by the del_marked_constants rule with priority 1).\n# To make that rule find the constants to be deleted, all constant arguments\'\n# to_delete (Python) attributes are set to True (1).\n\nargument_list = self.getMatched(graphID, self.LHS.nodeWithLabel(2)).out_connections_\nfor arg in argument_list:\n arg.to_delete = 1\n\n# All the constant arguments have been folded into a single constant node.\n# This is a newly created "constant" node and hence has no "to_delete" attribute yet.\n# Give it one (and set to False)\nself.getMatched(graphID, self.RHS.nodeWithLabel(3)).to_delete = 0\n\n# Find out what the operator is. As "alg_operator"\'s attribute "kind" is\n# an enumerated type, a tuple like ([\'+\', \'*\', \'inv\'], 0) will be returned.\n# The 0 is the position in the list of the operator\'s description (\'+\' in this case).\n(operator_enum, operator_index) = self.getMatched(graphID, self.LHS.nodeWithLabel(1)).kind.getValue()\noperator = operator_enum[operator_index]\n\n# set the initial folding result (only implemented for + and *)\nif operator == \'+\':\n result = 0\nelif operator == \'*\':\n result = 1\nelif operator == \'inv\':\n result = 0\nelse:\n result = -9999\n\n# apply the operator to all arguments\nfor arg in argument_list:\n value = arg.value.getValue()\n if operator == \'+\':\n  result += value\n elif operator == \'*\':\n  result *= value\n elif operator == \'inv\':\n  result -= value \n else:\n  print "constant folding not implemented for operator \'%s\'" % operator\n\n# Return the folded value \nreturn result\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n'))
      self.obj27.GGset2Any['value']= self.obj270
      self.RHS.addNode(self.obj27)

      self.obj28=operates_on(parent)

      self.obj28.GGLabel.setValue(0)
      self.obj28.graphClass_= graph_operates_on
      if parent.genGraphics:
         from graph_operates_on import *
         new_obj = graph_operates_on(243.0,48.0,self.obj28)
      else: new_obj = None
      self.obj28.graphObject_ = new_obj
      self.RHS.addNode(self.obj28)
      self.obj28.out_connections_.append(self.obj27)
      self.obj27.in_connections_.append(self.obj28)
   def condition(self, graphID, isograph, atom3i):
      # Only constant fold if all arguments are constants
      argument_list = self.getMatched(graphID, self.LHS.nodeWithLabel(2)).out_connections_
      for arg in argument_list:
       if not isinstance(arg, constant): return 0
      return 1
      
      
      
      
      
      

   def action(self, graphID, isograph, atom3i):
      # All the constant arguments have been folded and hence need to be deleted
      # (by the del_marked_constants rule with priority 1).
      # To make that rule find the constants to be deleted, all constant arguments'
      # to_delete (Python) attributes are set to True (1).
      
      print ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
      print dir(self)
      
      argument_list = self.getMatched(graphID, self.LHS.nodeWithLabel(2)).out_connections_
      for arg in argument_list:
       arg.to_delete = 1
      
      # All the constant arguments have been folded into a single constant node.
      # This is a newly created "constant" node and hence has no "to_delete" attribute yet.
      # Give it one (and set to False)
      self.getMatched(graphID, self.RHS.nodeWithLabel(3)).to_delete = 0
      
      
      
      
      
      
      

